//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                                                   Copyright  2012, Ivan Kornilov |
//|                                                                      BrakeExp.mq4 |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
#property copyright "Copyright  2010, Ivan Kornilov. All rights reserved."
#property link "excelf@gmail.com"
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_width1 2
#property indicator_color2 Red
#property indicator_width2 2
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  *****                  *****                  |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
extern double   ValueA      = 3;
extern double   ValueB      = 1;
extern bool     IsLine      = true;
//IIIIIIIIIIIIIIIIIII======  =====IIIIIIIIIIIIIIIIIIIIII+
double          buf_UP[], buf_DW[],
                gd_MaxPrice = -999,
                gd_MinPrice = 999,
                gd_BeginPrice = -1;
datetime        gdt_BeginTime = 0;
bool            gb_IsLong = true;
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|               Custom indicator initialization function                            |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int init()
{
//----
    IndicatorShortName ("BrakeExp (" + NormalizeDouble (ValueA, 2) + "," + NormalizeDouble (ValueB, 2) + " )");
    ValueB *= Point;
    ValueA *= 0.1;
    SetIndexBuffer (0, buf_UP);
    SetIndexLabel (0, "UP");
    SetIndexBuffer (1, buf_DW);
    SetIndexLabel (1, "DW");
    if (IsLine)
    {
        SetIndexStyle (0, DRAW_LINE, EMPTY, 2);
        SetIndexStyle (1, DRAW_LINE, EMPTY, 2);
    }
    else
    {
        SetIndexStyle (0, DRAW_ARROW, EMPTY, 2);
        SetIndexArrow (0, 159);
        SetIndexStyle (1, DRAW_ARROW, EMPTY, 2);
        SetIndexArrow (1, 159);
    }
    IndicatorDigits (Digits);   
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|               Custom indicator iteration function                                 |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int start()
{
    double ld_Value, ld_exp;
    int li_BeginBar, li_CountedBars = IndicatorCounted();
    if (li_CountedBars < 0) {return (-1);}
    if (li_CountedBars > 0) {li_CountedBars--;}
    int li_Limit = Bars - li_CountedBars - 2;
    if (li_Limit < 0) {return (-1);}
    //----  Limit  1,    
    if (li_Limit > 1) {li_Limit = Bars - 2; gd_BeginPrice = -1;}
    for (int i = li_Limit; i >= 0; i--)
    {
        if (gd_BeginPrice == -1)
        {
            gd_BeginPrice = Low[i];
            gdt_BeginTime = Time[i];
            gb_IsLong = true;
            Print ("init");
        }
        if (gd_MaxPrice < High[i]) {gd_MaxPrice = High[i];}
        if (gd_MinPrice > Low[i]) {gd_MinPrice = Low[i];}
        li_BeginBar = iBarShift (NULL, 0, gdt_BeginTime, false);
        ld_exp = (MathExp ((li_BeginBar - i) * ValueA) - 1) * ValueB;
        if (gb_IsLong) {ld_Value = gd_BeginPrice + ld_exp;}
        else {ld_Value = gd_BeginPrice - ld_exp;}
        if (gb_IsLong)
        {
            if (ld_Value > Low[i])
            {
                gb_IsLong = false;
                gd_BeginPrice = gd_MaxPrice;
                ld_Value = gd_BeginPrice;
                gdt_BeginTime = Time[i];
                gd_MaxPrice = -999;
                gd_MinPrice = 999;  
                //Print ("gb_IsLong && ld_Value > Low[i]");
            }
        }
        else if (ld_Value < High[i])
        {
            gb_IsLong = true;
            gd_BeginPrice = gd_MinPrice;
            ld_Value = gd_BeginPrice;
            gdt_BeginTime = Time[i];
            gd_MaxPrice = -999;
            gd_MinPrice = 999;
        }
        if (gb_IsLong)
        {
            buf_UP[i] = ld_Value;
            buf_DW[i] = EMPTY_VALUE;
        }
        else
        {
            buf_UP[i] = EMPTY_VALUE;
            buf_DW[i] = ld_Value;
        }
    }
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+

